addpath ../FEM1d
% problema1 Laboratorio 3
% definisco la geometria
geom.xa=0; geom.xb=1;
geom.t0=0; geom.tf=1;
% definisco i coefficienti 
problem_data.mu=1; 
problem_data.sigma=0;
problem_data.f=@(x,t)sin(x)*(cos(t)-sin(t));
problem_data.gd0=@(t)0+0*t; % dir a sx
problem_data.gd1=@(t)sin(1)*cos(t); % dir a dx
problem_data.gn0=@(t)0; % neu a sx
problem_data.gn1=@(t)0; % neu a dx
problem_data.u0=@(x)sin(x); % condizione iniziale
problem_data.bc='dd'; % tipo di condizioni al bordo
% parametri di discretizzazione
parameters.p=1; % grado polinomiale
parameters.Ne=125; % h=1/20
parameters.theta=1; % 1= Eulero implicito, 1/2 CN, 0 Eulero esplicito
parameters.Nt=20; % numero passi temporali
parameters.plot_solution=0; % per plottare la soluzione
parameters.plot_axis=[0,1]; % estremi in y per il plot
parameters.degree=4;
uex=@(x)sin(x)*cos(1); % sol esatta al tempo T=1
u1ex=@(x)cos(x)*cos(1); % du/dx al tempo T=1

% ciclo su Nt (su dt)
Dt=[ ]; Err=[ ];

for Nt= [20 40 80 160]
  parameters.Nt=Nt;
% chiamo la function di soluzione
[nodes,un1]=fem_1d_heat_solver(geom,problem_data,parameters);
% calcolo l'errore
errors=fem_1d_errors(un1,geom,parameters.p,parameters.Ne,...
  uex,u1ex);
h=(geom.xb-geom.xa)/parameters.Ne; % passo h
dt=(geom.tf-geom.t0)/parameters.Nt; % Delta t
fprintf('h= %f, dt=%f, err_L2 =%e \n',h,dt,errors.l2)
Dt=[Dt; dt];
Err=[Err; errors.l2];
end

% plot degli errori in sscala loglog
figure(2); clf
loglog(Dt,Err,'o-','Linewidth',2)
hold on
loglog(Dt,Dt,Dt,Dt.^2)
grid on
legend('err','dt','dt^2')
xlabel('dt')
ylabel('errore')

















