clear
% problema del Lab3
model = createpde; 
R1=[3,4, 0,1,1,0, 0,0,2,2]'; 
R2=[3,4, 0.3,0.4,0.4,0.3, 0.3,0.3,0.9,0.9]';
R3=[3,4, 0.5,0.6,0.6,0.5, 1.1,1.1,1.7,1.7]';
gd=[R1,R2,R3];
ns=(char('R1','R2','R3'))';
sf='R1-R2-R3'; % Dominio - cavita'
g=decsg(gd,sf,ns);
geometryFromEdges(model,g);
figure(1); clf
pdegplot(model,'EdgeLabels','on')
% coefficienti
rho=7.2;
Cp=500; k=50;
specifyCoefficients( model,'m',0,'d',rho*Cp,'c',k,'a',0,'f',0);
% condizioni al bordo
% lato sinistro
applyBoundaryCondition(model,'dirichlet','Edge',7,'u',373.15);
% lato destro
applyBoundaryCondition(model,'neumann','Edge',1,'q',25,'g',25*293);

% altri edge (neumann omogeneo
applyBoundaryCondition(model,'neumann','Edge',[2:6,8:12],'q',0,'g',0);
% condizione iniziale
setInitialConditions(model,273.15);

% mesh
generateMesh(model, 'Hmax',0.05,'GeometricOrder','quadratic');
% 
tlist=0:20; % tempo per i plot

% si modificano le tolleranze

results=solvepde(model,tlist);

% calcolo gradiente
[gradx,grady]=evaluateGradient(results);
clim=[min(min(results.NodalSolution)),max(max(results.NodalSolution))];

%% rappresento la soluzione
figure(2); clf
nt=size(tlist,2); % numero di istanti temporali
for n=1:nt
  u=results.NodalSolution(:,n); % estraggo solo la colonna n-sima della matrice
  pdeplot(model,'XYData',u,'Contour','on',...
    'FlowData',[-gradx(:,n),-grady(:,n)]);
  set(gca,'CLim',clim) % fisso la scala dei colori
  % gca=graphic current axis
  title(['t=',num2str(tlist(n))]);
  pause(0.25)
end

